#property  indicator_separate_window
#property  indicator_buffers 2
#property  indicator_color1  LimeGreen
#property  indicator_color2  DarkOrange
#property  indicator_width1  2
#property  indicator_width2  2
#property  indicator_minimum 0
#property  indicator_maximum 1

extern int FastEma    = 12;
extern int SlowEma    = 26;
extern int SignalEma  = 9;
extern int Price      = PRICE_CLOSE;

double signal[];
double barup[];
double bardn[];

//

int init()
{
   IndicatorBuffers(3);
   SetIndexBuffer(0,barup);  SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,bardn);  SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,signal); SetIndexStyle(1,DRAW_HISTOGRAM);
   return(0);
}
int deinit() { return(0); }
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         

         //

   double alpha = 2.0/(SignalEma+1);
   for (int i=limit; i>=0; i--)   
   {
      double macd = iMA(NULL,0,FastEma,0,MODE_EMA,Price,i)-iMA(NULL,0,SlowEma,0,MODE_EMA,Price,i);
         signal[i] = signal[i+1]+alpha*(macd-signal[i+1]);
         barup[i]  = EMPTY_VALUE;
         bardn[i]  = EMPTY_VALUE;
            if (signal[i] < macd) barup[i] = 1; 
            if (signal[i] > macd) bardn[i] = 1; 
   }
   return(0);
}